export var FetchLocalCache =
/*#__PURE__*/
function () {
  function FetchLocalCache(state) {
    this.state = state;
  }

  var _proto = FetchLocalCache.prototype;

  _proto.set = function set(id, value) {
    var item = {
      id: id,
      value: value,
      cachedAt: Date.now()
    };
    this.state[id] = item;
    return item;
  };

  _proto.get = function get(id) {
    return this.state[id];
  };

  _proto.remove = function remove(id) {
    delete this.state[id];
  };

  _proto.getState = function getState() {
    return this.state;
  };

  _proto.setState = function setState(state) {
    this.state = state;
  };

  return FetchLocalCache;
}();
export var createCache = function createCache(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      initialState = _ref.initialState;

  return new FetchLocalCache(initialState || {});
};