function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { useEffect, useMemo, useCallback, useState } from 'react';
import { useFetchClient } from './use-fetch-client';
import { actHack } from './act-hack';
export function useBaseFetchCache(fetchId) {
  var client = useFetchClient();

  var _useState = useState(client.get(fetchId)),
      value = _useState[0],
      setValue = _useState[1];

  useEffect(function () {
    return client.listen(fetchId, {
      update: function update(newValue) {
        actHack(function () {
          return setValue(newValue);
        });
      }
    });
  }, [client, fetchId, setValue]);
  var updateCacheValue = useCallback(function (newValue) {
    return client.set(fetchId, function (prevValue) {
      return _extends({}, prevValue, {}, newValue);
    });
  }, [client]);
  return useMemo(function () {
    return [value, updateCacheValue];
  }, [client, value]);
}
export var useFetchCache = useBaseFetchCache;