function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { useEffect, useState, useMemo, useCallback } from 'react';
import { actHack } from './act-hack';
import { useFetchClient } from './use-fetch-client';
export function useBaseFetch(config) {
  var client = useFetchClient();
  var fetchId = config ? config.id || client.idFromAction(config) : undefined;
  var cachedValue = fetchId ? client.get(fetchId) : undefined;

  var _useState = useState({
    value: cachedValue,
    loading: !cachedValue,
    lastFetchedFetchId: cachedValue ? fetchId : undefined
  }),
      state = _useState[0],
      setState = _useState[1];

  var dispatchAction = useCallback(function () {
    if (!config) {
      return Promise.reject(new Error('action is null'));
    } // if (!state.loading) {
    //   setState(prevState => ({ ...prevState, loading: true }))
    // }


    return client.dispatch(config, fetchId)["catch"](function (error) {
      actHack(function () {
        setState({
          value: {
            error: error
          },
          action: config,
          loading: false
        });
      });
      throw error;
    }).then(function (result) {
      actHack(function () {
        setState({
          value: result,
          action: config,
          loading: false
        });
      });
      return result;
    });
  }, [fetchId]);
  useMemo(function () {
    if (fetchId !== state.lastFetchedFetchId) {
      dispatchAction();
    }
  }, [client, fetchId]);
  useEffect(function () {
    if (fetchId) {
      var unlisten = client.listen(fetchId, {
        update: function update(newValue) {
          actHack(function () {
            setState({
              loading: false,
              value: newValue
            });
          });
        }
      });

      if (config && !cachedValue) {
        if (state.loading !== true) {
          setState({
            action: config,
            loading: true
          });
        }
      }

      return unlisten;
    }
  }, [client, fetchId]);
  var result = useMemo(function () {
    return _extends({}, state.value, {
      action: config || undefined,
      loading: state.loading,
      refetch: dispatchAction
    });
  }, [state]);
  return result;
}
export var useFetch = useBaseFetch;