import { FetchDispatcherResult, HeadersObject } from './client';
export interface FetchCache<TValue, TState> {
    set(id: string, value: TValue): CacheItem<TValue>;
    get(id: string): CacheItem<TValue> | undefined;
    remove(id: string): void;
    getState(): any;
    setState(newState: TState): void;
}
export interface CacheItem<TValue> {
    id: string;
    value: TValue;
    cachedAt: number;
}
export interface LocalCacheState {
    [key: string]: CacheItem<unknown>;
}
export declare class FetchLocalCache implements FetchCache<FetchDispatcherResult<any, HeadersObject>, any> {
    protected state: LocalCacheState;
    constructor(state: LocalCacheState);
    set<TValue>(id: string, value: TValue): CacheItem<TValue>;
    get<TValue>(id: string): CacheItem<TValue> | undefined;
    remove(id: string): void;
    getState(): LocalCacheState;
    setState(state: LocalCacheState): void;
}
interface CreateCacheConfig {
    initialState?: LocalCacheState;
}
export declare const createCache: ({ initialState, }?: CreateCacheConfig) => FetchLocalCache;
export {};
