"use strict";

exports.__esModule = true;
exports.useBaseFetchCache = useBaseFetchCache;
exports.useFetchCache = void 0;

var _react = require("react");

var _useFetchClient = require("./use-fetch-client");

var _actHack = require("./act-hack");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function useBaseFetchCache(fetchId) {
  var client = (0, _useFetchClient.useFetchClient)();

  var _useState = (0, _react.useState)(client.get(fetchId)),
      value = _useState[0],
      setValue = _useState[1];

  (0, _react.useEffect)(function () {
    return client.listen(fetchId, {
      update: function update(newValue) {
        (0, _actHack.actHack)(function () {
          return setValue(newValue);
        });
      }
    });
  }, [client, fetchId, setValue]);
  var updateCacheValue = (0, _react.useCallback)(function (newValue) {
    return client.set(fetchId, function (prevValue) {
      return _extends({}, prevValue, {}, newValue);
    });
  }, [client]);
  return (0, _react.useMemo)(function () {
    return [value, updateCacheValue];
  }, [client, value]);
}

var useFetchCache = useBaseFetchCache;
exports.useFetchCache = useFetchCache;