import { FetchActionCreator } from './action';
import { FetchHookResult } from './interfaces/hooks';
import { FetchDispatcherResult, DefaultFetchDispatcherResult } from './client';
export interface UseBaseFetchMutationResultWithNoExtraValues<TValue, TArg, TMeta> extends FetchHookResult<TValue, TMeta> {
    mutate: (arg?: TArg) => Promise<TValue>;
    reset: () => void;
    loading: boolean;
}
export declare type UseBaseFetchMutationResult<TValue, TArg, TMeta> = TValue & UseBaseFetchMutationResultWithNoExtraValues<TValue, TArg, TMeta>;
export declare function useBaseFetchMutation<TDispatcherResult extends FetchDispatcherResult<any, any>, TArg = any, TMeta = any>(actionCreator: FetchActionCreator<TArg, TMeta>): UseBaseFetchMutationResult<TDispatcherResult, TArg, TMeta>;
export interface UseFetchMutation {
    <TData, TArg = any, TMeta = any>(actionCreator: FetchActionCreator<TArg, TMeta>): UseBaseFetchMutationResult<DefaultFetchDispatcherResult<TData>, TArg, TMeta>;
}
export declare const useFetchMutation: UseFetchMutation;
